# losspercfinal <- read.csv("~/losspercfinal.csv")
# scenfinal <- read.csv("~/scenfinal.csv")
# rbc <- read.csv("~/rbc.csv", header=FALSE)

deals = nrow(scenfinal)
probs = 1000
scenm = 0
agg = 0

tranches = nrow(losspercfinal)

#  manually set the initial champion probability
#  winner = c(0.07,0.12,0.12,0.15,0.22,0.22,0.0574,0.04,0.0025,0.0001)

rec = matrix(ncol =12,nrow =probs)  # matrix for recording results
trisk = matrix(nrow = tranches,ncol=3)  #tranche risk matrix
tote = 0  #total error 



#  calculate the winner rbc
#  start by calculating the probability weight of each tranche
#  findInterval serves the same function as VLOOKUP(x,x:x,x,TRUE)

for (k in 1:tranches) {
  trisk[k,1] =losspercfinal[k,1]
# trisk[k,2] =lossperc2[k,2]  this was creating lots of probels
  trisk[k,3] = rbc[findInterval(sum(losspercfinal[k,4:13]*winner),rbc$V1),2]*losspercfinal[k,15]*(1-losspercfinal[k,3])
  trisk[k,3] = as.numeric(trisk[k,3]) + pmax(0,losspercfinal[k,14]*losspercfinal[k,3])
}




#  calculate the total rbc for each deal

agg=aggregate(V3~V1,trisk,sum)



#  merge the agg and the risk to calculate the SE

scenm =merge(scenfinal,agg, by.x = "MOODY.DEAL.ID", by.y = "V1",all.x = TRUE)

 

# calculate the MSE

win_mse = (sum((scenm$V3-scenm$Risk)^2))/deals



# run probability scenarios 
# 


win_scen = 0

for (i in 1:probs) {
  
  tote =0
  scenm=0
  
  
  #normalize probailities
  
  rawr = pmax(rnorm(10, mean = 0, sd = .125),0)
  rawr2 = pmax(0,winner+winner * rawr)
  normr = rawr2 / sum(rawr2)
  
  for (k in 1:tranches) {

    trisk[k,3] = rbc[findInterval(sum(losspercfinal[k,4:13]*normr),rbc$V1),2]*losspercfinal[k,15]*(1-losspercfinal[k,3])
    trisk[k,3] = as.numeric(trisk[k,3]) + pmax(0,losspercfinal[k,14]*losspercfinal[k,3])
  }


  # cond = probmatrix[i,10] <= 0.001 && probmatrix[i,10] <= 0.0025 && (probmatrix[i,7]+probmatrix[i,8]+probmatrix[i,9]+probmatrix[i,10])<=0.02
  
  
  
  #  calculate the total rbc for each deal
  
  agg=aggregate(V3~V1,trisk,sum)
  
  #  merge the agg and the risk to calculate the SE
  
  scenm =merge(scenfinal,agg, by.x = "MOODY.DEAL.ID", by.y = "V1", all.x = TRUE)
  
  print(i)
  
  # calculate the MSE
  
  tote = sum((scenm$V3-scenm$Risk)^2)/deals
  
  rec[i,1]=i
  rec[i,2]=tote
  rec[i,3:12]=normr
  

  
  if (tote < win_mse) {
    win_mse = tote
    winner = normr
    win_scen=i
    
  }
  
  
  
}

